#version 150 core

in vec2 pos;  // screen position <-1,+1>

uniform sampler2D textureBuffer;
uniform vec2      screenSize;
uniform float     blurRadius;
uniform int       axis;

out vec4 color;

void main() {
  float x, y, rr = blurRadius * blurRadius, d, w, w0;
  vec2  p   = 0.5 * ( vec2( 1.0f, 1.0f ) + pos );
  vec4  col = vec4( 0.0f, 0.0f, 0.0f, 0.0f );
  w0        = 0.5135f / pow( blurRadius, 0.96f );
  if ( axis == 0 ) {
    for ( d = 1.0f / screenSize.x, x = -blurRadius, p.x += x * d; x <= blurRadius; x++, p.x += d ) {
      w = w0 * exp( ( -x * x ) / ( 2.0f * rr ) );
      col += textureLod( textureBuffer, p, 0 ) * w;
    }
  } else if ( axis == 1 ) {
    for ( d = 1.0f / screenSize.y, y = -blurRadius, p.y += y * d; y <= blurRadius; y++, p.y += d ) {
      w = w0 * exp( ( -y * y ) / ( 2.0f * rr ) );
      col += textureLod( textureBuffer, p, 0 ) * w;
    }
  }
  color = col;
}
