#version 110

attribute vec3 inVertex;
attribute vec3 inTextureCoord;
attribute vec3 inNormal;
attribute vec3 inTangent;

uniform vec3 wsLightDir;
uniform mat4 viewProjectionMatrix;
uniform mat4 modelMatrix;

varying vec2 textureCoord;
varying vec3 lightDir;
varying mat3 tbnMatrix;

void main() {
  gl_Position = viewProjectionMatrix * modelMatrix * vec4( inVertex, 1.0 );

  textureCoord = inTextureCoord.xy;
  lightDir     = wsLightDir;

  // создаем матрицу перевода направления в координаты пространства мира
  mat3 normalMatrix = mat3( modelMatrix[ 0 ].xyz, modelMatrix[ 1 ].xyz, modelMatrix[ 2 ].xyz );
  vec3 wsNormal     = normalize( normalMatrix * inNormal );
  vec3 wsTangent    = normalize( normalMatrix * inTangent );
  vec3 wsBitangent  = normalize( cross( wsNormal, wsTangent ) );
  tbnMatrix         = mat3( wsTangent, wsBitangent, wsNormal );
}
